package com.steerinfo.appservice.appcmmcarweightresults.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.appservice.appcmmcarweightresults.model.AppCmmCarweightresults;
import com.steerinfo.appservice.appcmmcarweightresults.service.IAppCmmCarweightresultsService;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * AppCmmCarweightresults RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-11-05 11:06
 * 类描述
 * 修订历史：
 * 日期：2021-11-05
 * 作者：generator
 * 参考：
 * 描述：AppCmmCarweightresults RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/appservice/appcmmcarweightresultss")
public class AppCmmCarweightresultsController extends BaseRESTfulController {

    @Autowired
    IAppCmmCarweightresultsService appCmmCarweightresultsService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("appcmmcarweightresults:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<AppCmmCarweightresults> list = appCmmCarweightresultsService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("appcmmcarweightresults:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<AppCmmCarweightresults> list = appCmmCarweightresultsService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据AppCmmCarweightresults对象创建")
    @ApiImplicitParam(name = "appCmmCarweightresults", value = "详细实体appCmmCarweightresults", required = true, dataType = "AppCmmCarweightresults")
    //@RequiresPermissions("appcmmcarweightresults:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute AppCmmCarweightresults model){
        AppCmmCarweightresults appCmmCarweightresults = appCmmCarweightresultsService.add(model);
        return success(appCmmCarweightresults);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("appcmmcarweightresults:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        AppCmmCarweightresults appCmmCarweightresults = appCmmCarweightresultsService.getById(id);
        return success(appCmmCarweightresults);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的appCmmCarweightresults信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "appCmmCarweightresults", value = "详细实体appCmmCarweightresults", required = true, dataType = "AppCmmCarweightresults")
    })
    //@RequiresPermissions("appcmmcarweightresults:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody AppCmmCarweightresults model){
        model.setId(id);
        AppCmmCarweightresults appCmmCarweightresults = appCmmCarweightresultsService.modify(model);
        return success(appCmmCarweightresults);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("appcmmcarweightresults:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  appCmmCarweightresultsService.delete(ids);
    	}
      return success();
    }


    @ApiOperation(value = "车辆管理-计量实绩-明细查询（旧系统）", notes = "根据车号参数查询数据，查询明细数据")
    @GetMapping(value = "/selectNetByCarOld")
    public RESTfulResult selectNetByCarOld(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<AppCmmCarweightresults> list = appCmmCarweightresultsService.selectNetByCarOld(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "车辆管理-计量实绩-分类查询汇总（旧系统）", notes = " 通过车号获取总数,分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    @GetMapping(value = "/selectSumForAppByCarOld")
    public RESTfulResult selectSumForAppByCarOld(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<AppCmmCarweightresults> list = appCmmCarweightresultsService.selectSumForAppByCarOld(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
